# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Safe-Isa
Version:	1.000010
Release:	16.%{__distinit}%{__distvers}
Summary:	Call isa, can, does and DOES safely on things that may not be objects
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Safe-Isa
Source0:	https://cpan.metacpan.org/authors/id/E/ET/ETHER/Safe-Isa-%{version}.tar.gz
BuildArch:	noarch
# Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module
BuildRequires:	perl(Exporter) >= 5.57
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(Test::More) >= 0.82
BuildRequires:	perl(UNIVERSAL)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

%description
This module allows you to call isa, can, does and DOES safely on things that
may not be objects, without the risk of crashing.

%prep
%setup -q -n Safe-Isa-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc Changes README
%{perl_vendorlib}/Safe/
%{_mandir}/man3/Safe::Isa.3*

%changelog
* Tue May 16 2023 Paul Howarth <paul@city-fan.org> - 1.000010-16
- Use SPDX-format license tag

* Thu Jun  6 2019 Paul Howarth <paul@city-fan.org> - 1.000010-5
- Perl 5.30 rebuild

* Thu Apr 26 2018 Paul Howarth <paul@city-fan.org> - 1.000010-1
- Update to 1.000010
  - Fix DOES tests on 5.8.x

* Tue Apr 24 2018 Paul Howarth <paul@city-fan.org> - 1.000009-1
- Update to 1.000009
  - Fix handling of DOES and does (they no longer fall back to isa in most
    situations outside of Moo/Moose)

* Tue Oct  3 2017 Paul Howarth <paul@city-fan.org> - 1.000008-1
- Update to 1.000008
  - Fix scalar/list context handling for $_call_if_can

* Mon Sep 25 2017 Paul Howarth <paul@city-fan.org> - 1.000007-1
- Update to 1.000007
  - Added new interface: $obj->$_call_if_can
- This release by ETHER → update source URL
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Tue Nov  1 2016 Paul Howarth <paul@city-fan.org> - 1.000006-1
- Update to 1.000006
  - Now falling back to $obj->isa if DOES/does is not implemented on the
    object, to avoid fatal errors on perls too old to have their own DOES
    (CPAN RT#100866)
- This release by HAARG → update source URL

* Fri Sep 23 2016 Paul Howarth <paul@city-fan.org> - 1.000005-6
- BR: perl-generators where available
- Simplify find command using -delete

* Mon Oct 13 2014 Paul Howarth <paul@city-fan.org> - 1.000005-1
- Initial RPM version
